import java.math.BigInteger

// var count = 1
val big2 = BigInteger("2")
val big3 = BigInteger("3")

fun main() {
  var startingN = BigInteger("10").pow(100000)
  while(true) {
    // print("Num: $startingN, ")
    var count = f(startingN)
    println("Count: $count")
    startingN = startingN.inc()
  }
}

fun f(nPrime: BigInteger): Int {
  var count = 1
  var n = nPrime
  while (!n.equals(BigInteger.ONE)) {
    val isEven = n.rem(big2).equals(BigInteger.ZERO)
    count++
    if(isEven) {
      n = n.div(big2)
    } else {
      n = n.times(big3).inc()
    }
  }
  return count
}

/*
f :: Integer -> Integer
f n = s 1 n
  where
    s :: Integer -> Integer -> Integer
    s i n
      | n ==    1  = i
      | n ==    0  = i
      | n ==  (-1) = i
      | n ==  (-5) = i
      | n == (-17) = i
      | even n = s (succ i) (n `div` 2)
      | odd  n = s (succ i) (3*n + 1)
*/